// Code generated by go-swagger; DO NOT EDIT.

package images

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// ImageBuildHandlerFunc turns a function with the right signature into a image build handler
type ImageBuildHandlerFunc func(ImageBuildParams) middleware.Responder

// Handle executing the request and returning a response
func (fn ImageBuildHandlerFunc) Handle(params ImageBuildParams) middleware.Responder {
	return fn(params)
}

// ImageBuildHandler interface for that can handle valid image build params
type ImageBuildHandler interface {
	Handle(ImageBuildParams) middleware.Responder
}

// NewImageBuild creates a new http.Handler for the image build operation
func NewImageBuild(ctx *middleware.Context, handler ImageBuildHandler) *ImageBuild {
	return &ImageBuild{Context: ctx, Handler: handler}
}

/*ImageBuild swagger:route POST /api/images Images imageBuild

Build image for virtual machine

*/
type ImageBuild struct {
	Context *middleware.Context
	Handler ImageBuildHandler
}

func (o *ImageBuild) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewImageBuildParams()

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
